/**
* @@@BUILDINFO@@@ MrConnectTextlinePoint.jsx !Version! Wed Jul 25 2007 16:11:47 GMT+0200
*/
#include ./lib/bene.jsx
/////////////////////////////////////////////////////////////////////////////////////////////
// Feel free to use / modify this code however you wish. 
// We would be happy if you would make a reference to  
// www.looksgood.de and to generative-systeme.de
//
// Benedikt Gro & Julia Laub
// benedikt@looksgood.de / julia@generative-systeme.de
/////////////////////////////////////////////////////////////////////////////////////////////
var myScriptName = app.activeScript.name;

var myObjectList = new Array;
if (app.documents.length != 0){
	if (app.selection.length != 0){
		for(var myCounter = 0;myCounter < app.selection.length; myCounter++){
			switch (app.selection[myCounter].constructor.name){
				//allow only textframes
				case "TextFrame":
					myObjectList.push(app.selection[myCounter]);
					break;
			}
		}
		if (myObjectList.length != 0){
			myInterface();
		}
		else{
			alert ("Please select TextFrame and try again.");
		}
	}
	else{
		alert ("Please select an object and try again.");
	}
}
else{
    alert ("Please open a document, select an object, and try again.");
}

/////////////////////////////////////////////////////////////////////////////////////////////
//functions

//interface
function myInterface(){
	//Simple User Interface Example
	var myDialog = app.dialogs.add({name:myScriptName,canCancel:true});
	with(myDialog){		
		//Add a dialog column.
		with(dialogColumns.add()){	
			staticTexts.add({staticLabel:"Point X:"});
			staticTexts.add({staticLabel:"Point Y:"});
		}	
		
		//Add a dialog column.
		with(dialogColumns.add()){		
			//Create a number (real) entry field.
			var myInput1 = realEditboxes.add({editValue:0});				
			//Create a number (real) entry field.
			var myInput2 = realEditboxes.add({editValue:0});
		}	
		
		//Add a dialog column.
		with(dialogColumns.add()){
		//Create another border panel.
			with(borderPanels.add()){
				staticTexts.add({staticLabel:"Connect to:"});
				var myRadioButtonGroup = radiobuttonGroups.add();
				with(myRadioButtonGroup){
					var myLeftRadioButton = radiobuttonControls.add({staticLabel:"Line beginning"});
					var myRightRadioButton = radiobuttonControls.add({staticLabel:"Line end", checkedState:true});
				}
			}
		}	
	
		
				
	}
	//Display the dialog box.
	var myResult = myDialog.show();
	if(myResult == true){
		var myFlag = false;
		if(myRadioButtonGroup.selectedButton == 1) myFlag = true;
		
		//Get the values from the dialog box controls.
		//run the thing!
		myConnectLinesCurve(myObjectList,myFlag,myInput1.editValue,myInput2.editValue);
			
		//Remove the dialog box from memory.
		myDialog.destroy();	
	} else{
		//User clicked Cancel, so remove the dialog box from memory.
		myDialog.destroy();
	}
}

///main thing
function myConnectLinesCurve(myObjectList,myFlag,myInput1,myInput2){
	var myDocument = app.activeDocument;
	var myLayer, myCounter, myColor;
	var myBounds, myX1, myY1, myX2, myY2;
	
	//Measurement
	var myOldRulerOrigin = myDocument.viewPreferences.rulerOrigin;
	myDocument.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
	//Save the current measurement units.
	var myOldXUnits = myDocument.viewPreferences.horizontalMeasurementUnits;
	var myOldYUnits = myDocument.viewPreferences.verticalMeasurementUnits;
	//Set the measurement units to points.
	myDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	myDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
	
	//Get references  the None swatch.		
	var myNoneSwatch = myDocument.swatches.item("None");	
	
	//Create a color (if it does not already exist).	
	myColor = myDocument.colors.item(myScriptName);
	try{
		myColorName = myColor.name;
	}
	catch (myError){
		var myColorArray = new Array(100, 0, 0, 0);
		myColor = myDocument.colors.add({model:ColorModel.process, space: ColorSpace.CMYK, colorValue:myColorArray,name: myScriptName});
	}
	
	//Create a layer to hold the generated lines (if it does not already exist).
	myLayer = myDocument.layers.item(myScriptName);
	try{
		myLayerName = myLayer.name;
	}
	catch (myError){
		myLayer = myDocument.layers.add({name:myScriptName});
	}
	
	
	//Process the objects (here text frames) in the selection.	
	for(myCounter = 0; myCounter < myObjectList.length; myCounter ++){
		//get page
		var myPage = myObjectList[myCounter].parent.documentOffset-1;
		//get textframe
		var myNewFrame = myObjectList[myCounter];
		//get bounding box
		myBounds = myNewFrame.visibleBounds;
		myY1 = myBounds[0];
		myX1 = myBounds[1];
		myY2 = myBounds[2];
		myX2 = myBounds[3];
		//get all lines in the frame
		var myLines = myNewFrame.lines;
		//draw for each textline the lines
		for(myLineCounter = 0; myLineCounter < myLines.length; myLineCounter ++){
			var myLine = myLines[myLineCounter];
			var myTmpY = myLine.baseline-0;
			
			
			//var myLinePercents = (myX2-myLine.insertionPoints[-2].horizontalOffset)/(myX2-myX1);
			//map ranges
			//var linewidth = myMapRange(myLinePercents,0,1,8,1);
			
			//array for points
			var myPathPoints = new Array;
			var myPointX = myInput1; 
			var myPointY = myInput2; 
			
			//add points X/Y
			
			if (myFlag == 1){
				//from point to end of the lines
				myPathPoints.push([myLine.insertionPoints[-2].horizontalOffset,myTmpY]);
				myPathPoints.push([myPointX,myPointY]);
				}else{
				//from point to start of the lines
				myPathPoints.push([myLine.insertionPoints[0].horizontalOffset,myTmpY]);
				myPathPoints.push([myPointX,myPointY]);	
				}
			
			//draw the line
			myDrawPolygon(myPathPoints, 1, 100, myColor, myNoneSwatch, myLayer);
		}	
	}	
	
	myDocument.viewPreferences.rulerOrigin = myOldRulerOrigin;
	//Set the measurement units back to their original state.
	myDocument.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
	myDocument.viewPreferences.verticalMeasurementUnits = myOldYUnits;
	
}