/**
* @@@BUILDINFO@@@ MrTweenCharacterPointsize.jsx !Version! Wed Jul 25 2007 15:50:40 GMT+0200
*/
/////////////////////////////////////////////////////////////////////////////////////////////
// Feel free to use / modify this code however you wish. 
// We would be happy if you would make a reference to  
// www.looksgood.de and to generative-systeme.de
//
// Benedikt Gro & Julia Laub
// benedikt@looksgood.de / julia@generative-systeme.de
/////////////////////////////////////////////////////////////////////////////////////////////

#include ./lib/bene.jsx 
//InDesign CS2 JavaScript
//Set to 4.0 scripting object model
app.scriptPreferences.version = 4.0;

/////////////////////////////////////////////////////////////////////////////////////////////
var myScriptName = app.activeScript.name;

var myObjectList = new Array;
if (app.documents.length != 0){
	if (app.selection.length != 0){
		for(var myCounter = 0;myCounter < app.selection.length; myCounter++){
			//alert(app.selection[0].constructor.name+" "+app.selection.length);
			switch (app.selection[myCounter].constructor.name){
				case "Text":
				case "TextFrame":
				case "Word":
				case "Line":
				case "Paragraph":
					myObjectList.push(app.selection[myCounter]);
					break;
			}
		}
		if (myObjectList.length != 0){
			//run the thing! call a function			
			myInterface();			
		}
		else{
			alert ("Please select a TextFrame only or select a Text");
		}
	}
	else{
		alert ("Please select an object and try again.");
	}
}
else{
    alert ("Please open a document, select an object, and try again.");
}





/////////////////////////////////////////////////////////////////////////////////////////////
//interface
function myInterface(){
	//Simple User Interface Example
	var myDialog = app.dialogs.add({name:myScriptName,canCancel:true});
	with(myDialog){
			
		//Add a dialog column.
		with(dialogColumns.add()){
		//Create another border panel.
			with(borderPanels.add()){
				staticTexts.add({staticLabel:"tween style:"});
				var myRadioButtonGroup = radiobuttonGroups.add();
				with(myRadioButtonGroup){
					var myRadioButton1 = radiobuttonControls.add({staticLabel:"go down", checkedState:true});
					var myRadioButton2 = radiobuttonControls.add({staticLabel:"go up"});
					var myRadioButton3 = radiobuttonControls.add({staticLabel:"go up and come back"});
					var myRadioButton4 = radiobuttonControls.add({staticLabel:"go down and come back"});
				}
			}
		}	
	
		
		//Add a dialog column.
		with(dialogColumns.add()){
			staticTexts.add({staticLabel:"fontsize start (pt)"});	
			staticTexts.add({staticLabel:"fontsize end (pt)"});
		}
		
		
		//Add a dialog column.
		with(dialogColumns.add()){		
			//Create a number (real) entry field.
			var myInput2 = realEditboxes.add({editValue:22});
			var myInput1 = realEditboxes.add({editValue:11});				
		}	
		
				
	}
	//Display the dialog box.
	var myResult = myDialog.show();
	if(myResult == true){
		
		//Get the values from the dialog box controls.
		//run the thing!
		tweenPointsize(myObjectList,myInput1.editValue,myInput2.editValue,myRadioButton1.checkedState,myRadioButton2.checkedState,myRadioButton3.checkedState,myRadioButton4.checkedState);
			
		//Remove the dialog box from memory.
		myDialog.destroy();	
	} else{
		//User clicked Cancel, so remove the dialog box from memory.
		myDialog.destroy();
	}
}

//Main thing
function tweenPointsize(myObjectList,in1,in2,radio1,radio2,radio3,radio4){
	var myDocument = app.activeDocument;
	var myCounter;	
	var myCounter = 0;
	
	//Process the objects (here text frames) in the selection.	
	for(i = 0; i < myObjectList.length; i++){
		//get textframe
		var myNewFrame = myObjectList[i];		
		//get all characters in the frame
		var myCharacters = myNewFrame.characters;
		//alert(myCharacters.length);

		for(myCharCounter = 0; myCharCounter < myCharacters.length; myCharCounter ++){
			//get char
			var myCharacter = myCharacters[myCharCounter];	
			var myTmpInterpolate = 0;			
			//set font size
			if (radio1) {
				//map to 0-1
				myTmpInterpolate = myMapRange(myCounter,0,myCharacters.length-1,0,1);	
				//interpolate different to linear from 0 to 1
				myTmpInterpolate = myBezierMapRange(myTmpInterpolate, 1.25, 0.6);
				//set size
				myCharacter.pointSize = (myMapRange(myTmpInterpolate,0,1,in2,in1));
			} else if (radio2){
				//map to 0-1
				myTmpInterpolate = myMapRange(myCounter,0,myCharacters.length-1,0,1);	
				//interpolate different to linear
				myTmpInterpolate = myBezierMapRange(myTmpInterpolate, 1.25, 0.6);	
				myCharacter.pointSize = (myMapRange(myTmpInterpolate,0,1,in1,in2));
			} else if (radio3){
				//map in intervals
				if (myCounter < (myCharacters.length-1)/2) {
					myTmpInterpolate = myMapRange(myCounter,0,(myCharacters.length-1)/2,0,1);	
				} else {
					myTmpInterpolate = myMapRange(myCounter,(myCharacters.length-1)/2,(myCharacters.length-1),1,0);
				}
				//interpolate different to linear
				myTmpInterpolate = myBezierMapRange(myTmpInterpolate, 1.0, 0.4);	
				myCharacter.pointSize = (myMapRange(myTmpInterpolate,0,1,in1,in2));
			} else if (radio4){
				//map in intervals
				if (myCounter < (myCharacters.length-1)/2) {
					myTmpInterpolate = myMapRange(myCounter,0,(myCharacters.length-1)/2,0,1);	
				} else {
					myTmpInterpolate = myMapRange(myCounter,(myCharacters.length-1)/2,(myCharacters.length-1),1,0);
				}
				//interpolate different to linear
				myTmpInterpolate = myBezierMapRange(myTmpInterpolate, 1.0, 0.8);	
				myCharacter.pointSize = (myMapRange(myTmpInterpolate,0,1,in2,in1));
			}
			myCounter++;					
		}		
	}		
}