/**
* @@@BUILDINFO@@@ bene.jsx !Version! Wed Jul 25 2007 16:04:02 GMT+0200
*/

//maps a source range to another
function myMapRange(input,sourcemin,sourcemax,destinationmin,destinationmax){
	var result = ((input-sourcemin)/(sourcemax-sourcemin))*(destinationmax-destinationmin)+destinationmin
	if (result < sourcemin) input = sourcemin;
	if (result > sourcemax) input = sourcemax;	
	return result;
}

//bezierfunction maping
function myBezierMapRange (theDelta, theStartControl, theEndControl) {
  var c = 3 * theStartControl;
  var b = 3 * (theEndControl - theStartControl) - c;
  var a = 1 - c - b;
  return a * theDelta * theDelta * theDelta + b * theDelta * theDelta + c * theDelta;
}

//draw a polygon lines
function myDrawPolygon(myPoints, myStrokeWeight, myStrokeTint, myRegistrationColor, myNoneSwatch, myLayer){	
	//Create a new polygons and assign it to the variable "myTextFrame"
	var myObject = app.activeWindow.activeSpread.polygons.add(myLayer, undefined, undefined,{strokeWeight:myStrokeWeight, strokeTint:myStrokeTint, fillColor:myNoneSwatch, strokeColor:myRegistrationColor})
	myObject.paths.item(0).entirePath = myPoints;
}

//draw straight lines
function myDrawLine(myBounds, myStrokeWeight, myStrokeTint, myRegistrationColor, myNoneSwatch, myLayer){
	app.activeWindow.activeSpread.graphicLines.add(myLayer, undefined, undefined,{strokeWeight:myStrokeWeight, strokeTint:myStrokeTint, fillColor:myNoneSwatch, strokeColor:myRegistrationColor, geometricBounds:myBounds})
}

//draw a polygon anchored lines
function myDrawCurve(myPoints, myLeftDirectionPoints, myRightDirectionPoints, myStrokeWeight, myStrokeTint, myRegistrationColor, myNoneSwatch, myLayer){	
	//Create a new polygons and assign it to the variable "myTextFrame"
	var myObject = app.activeWindow.activeSpread.graphicLines.add(myLayer, undefined, undefined,{strokeWeight:myStrokeWeight, strokeTint:myStrokeTint, fillColor:myNoneSwatch, strokeColor:myRegistrationColor})
	myObject.paths.item(0).entirePath = myPoints;
	for(var i = 0; i < myObject.paths.item(0).entirePath.length; i++){ 
		myObject.paths.item(0).pathPoints[i].leftDirection = myLeftDirectionPoints[i];
		myObject.paths.item(0).pathPoints[i].rightDirection = myRightDirectionPoints[i];
	}
}

//gets a random number in the range myStart to myEnd.
function myGetRandom(myStart, myEnd){
	var myRange = myEnd - myStart; 
	return myStart + Math.floor(Math.random()*myRange); 
}

//round number
function myRound(x,theInterval1,theInterval2,theInterval3) {
	if (x<theInterval1) {
		var k = (Math.round(x * 100) / 100).toString();
		k += (k.indexOf('.') == -1)? '.00' : '00';
		return k.substring(0, k.indexOf('.') + 0);
	} else if (x<theInterval2) {
		var k = (Math.round(x * 100) / 100).toString();
		k += (k.indexOf('.') == -1)? '.00' : '00';
		return k.substring(0, k.indexOf('.') + 2);
	} else if (x<theInterval3) {
		var k = (Math.round(x * 100) / 100).toString();
		k += (k.indexOf('.') == -1)? '.00' : '00';
		return k.substring(0, k.indexOf('.') + 3);
	} else {
		var k = (Math.round(x * 100) / 100).toString();
		k += (k.indexOf('.') == -1)? '.00' : '00';
		return k.substring(0, k.indexOf('.') + 4);
	}
}